#ifndef ARM_H
#define ARM_H
#define uchar unsigned char

/*  uses JDG's arm_v3

notes:

  random changed to rand to allow linking
  N.B. check rand as may not produce 32-bit no.s


needs:

  1. long multiply  - draughted BUT NOT TESTED
  2. btb updating for thumb
  3. more thumb testing

lsl routine added but not fully tested (28/10/98)
Long multiplication written (27/1/00)
Architecture V5 added (2/2/00)

To do:
   check long muls
         Flag checking (immediates ?!)
      Validation
   interrupt enable behaviour on exceptions (etc.)
*/
/* NB "int" is assumed to be at least 32-bit */

/* Stripped exectution code (9/8/00) */


/* ARM disassemble */
void arm_disassemble(unsigned int address, unsigned int op_code);
void dis_data_op(unsigned int address, unsigned int op_code, int cc);
void dis_transfer(unsigned int address, unsigned int op_code, int cc);
void dis_multiple(unsigned int address, unsigned int op_code, int cc);
void dis_branch(unsigned int address, unsigned int op_code, int cc);
void dis_coprocessor(unsigned int address, unsigned int op_code, int cc);
void dis_system(unsigned int address, unsigned int op_code, int cc);
void dis_dat(unsigned int address, unsigned int op_code, int cc, int operation);
void dis_mul(unsigned int address, unsigned int op_code, int cc);
void dis_swp(unsigned int address, unsigned int op_code, int cc);
void dis_shift(unsigned int op_code);
void dis_immediate(unsigned int op2);
void dis_transfer_offset(int op2, int add, int imm, int sbhw);
void dis_mrs(unsigned int address, unsigned int op_code, int cc);
void dis_msr(unsigned int address, unsigned int op_code, int cc);
void dis_bx(unsigned int address, unsigned int op_code, int cc);
void dis_sbhw(unsigned int address, unsigned int op_code, int cc); /* signed byte - hw */
void dis_cc(int cc, int *spaces);
void dis_tab(int spaces);

/* THUMB disassemble */
void thumb_disassemble(unsigned int address, unsigned int op_code);
void case0_addr(unsigned int op_code, char *mnemonic);
void dis_data0(unsigned int address, unsigned int op_code);
void dis_data1(unsigned int address, unsigned int op_code);
void dis_data_transfer(unsigned int address, unsigned int op_code);
void dis_transfer0(unsigned int address, unsigned int op_code);
void dis_transfer1(unsigned int address, unsigned int op_code);
void dis_sp_pc(unsigned int address, unsigned int op_code);
void dis_lsm_b(unsigned int address, unsigned int op_code);
void dis_thumb_branch1(unsigned int op_code, int exchange);
void dis_thumb_branch(unsigned int address, unsigned int op_code);
void print_reg_list(int i);

/* SHIFTS */
int lsl(int value, int distance, int *cf);
int lsr(unsigned int value, int distance, int *cf);
int asr(int value, int distance, int *cf);
int ror(unsigned int value, int distance, int *cf);
int is_it_sbhw(unsigned int);


/* Thumb stuff */
int BL_prefix, BL_address;

/* String Return pointer*/
char* dis_string_ptr;


#endif
