#ifndef ASM_H
#define ASM_H

#include <glib.h>

#define uchar unsigned char

#define DEFINITIONSTRING "define"
#define INTIGERSTRING "int"
#define RELATIVESTRING "relative"
#define UINTIGERSTRING "uint"
#define URELATIVESTRING "urelative"


typedef enum {NONTERM, TERM, TERM2FREE, NONTERM2FREE} RuleElementType;
typedef enum {TRANRULE, INTRULE, RELATIVERULE, UINTRULE, URELATIVERULE} RuleType;


typedef struct DefinitionStackName{
 struct DefinitionStackName* next;
 char* string;
 GList* rules;
 } DefinitionStack;

typedef struct {
 char* string;
 RuleElementType type; 
 int twin;
 GList* rules;
 } RuleElement;

typedef struct {
 RuleType type;
 GList* asci;
 GList* bit;
 } Rule;

typedef struct {
 GList* distext;
 GList* bitfield;
} Disasm;

typedef struct {
 GList* binary;
 char* text;
} Asm;

GList dis_error;



DefinitionStack* asm_parser (GList*);
DefinitionStack* asm_define (GList*, DefinitionStack*, char*);
Rule* 			 asm_rule   (GList*, DefinitionStack*);
Disasm asm_disassemble(GList* bitfield,GList* rules,int);
Asm asm_assemble(char*,GList* rules,int,int,int);
GList* uchararr2glist(int, uchar*);
void asm_print(GList*);
char* asm_sprint (GList* list, char*);
void asm_freestringlist(GList*);
char* asm_sprint_tabstring (char*,char*);
#endif
